<template>
  <div class="offers-page">
    <div class="section">
      <div class="container-fluid">
        <div class="wrapper">
          <h1 data-aos="fade" class="h2 bottom-green-line">Oferta</h1>
          <div data-aos="fade" class="offers bottom-silver-line" v-if="data.offers">
            <div class="tabs">
              <div class="tabs__tab"
                   v-for="(offer, idx) in data.offers"
                   :key="`${idx}-tab`"
                   @click="tab = idx"
                   :class="{active: tab === idx}">
                {{ offer.acf.name }}
              </div>
            </div>
          </div>
          <div
            v-if="tab === 0 || tab === 1"
            class="section__header bottom-silver-line"
            :class="{'only-mobile': tab !== 0 && tab === 1}"
          >
            <div v-if="tab === 1" data-aos="fade" class="section__header__shop">
              Sklep
            </div>
            <div v-if="tab === 0" data-aos="fade" class="section__count-products">
              Liczba masaży: <span>{{ countProducts }}</span>
            </div>
            <div v-if="data.products" class="section__filter-mobile js-filter-mobile">
              Filtry
              <svg xmlns="http://www.w3.org/2000/svg" width="13.852" height="8.691" viewBox="0 0 13.852 8.691">
                <g id="Group_5204" data-name="Group 5204" transform="translate(8.061 1.061)">
                  <line id="Line_1" data-name="Line 1" x2="6.57" y2="6.57" transform="translate(-7)" fill="none"
                        stroke="#97c35b" stroke-width="3"/>
                  <line id="Line_2" data-name="Line 2" x1="6.57" y2="6.57" transform="translate(-1.84)" fill="none"
                        stroke="#97c35b" stroke-width="3"/>
                </g>
              </svg>
            </div>
          </div>
          <template v-if="tab === 1">
            <div data-aos="fade" class="steps" v-if="data.offers[1].acf.show_steps">
              <h2 class="steps__title h2" v-if="data.offers[1].acf.steps.title"
                  v-html="data.offers[1].acf.steps.title"></h2>
              <div class="steps__items row" v-if="data.offers[1].acf.steps.step">
                <div class="steps__step" v-for="(step, idx) in data.offers[1].acf.steps.step"
                     :class="[idx % 2 === 0 ? 'col-lg-5' : 'col-lg-7']">
                  <div class="steps__step__number">
                    <svg xmlns="http://www.w3.org/2000/svg" width="64.85" height="57.048" viewBox="0 0 64.85 57.048">
                      <g id="Group_5099" data-name="Group 5099" transform="translate(-227.986 -524.788)">
                        <path id="Path_5300" data-name="Path 5300"
                              d="M10.082,5.889C17.487-.73,29.5-2.166,37.568,3.621c5.811,4.166,8.951,11.3,9.753,18.4.963,8.538-1.272,17.579-6.874,24.094s-14.7,10.129-23.105,8.327C9.143,52.684,1.847,44.872.428,36.651-1.312,26.566,2.322,12.824,10.082,5.889Z"
                              transform="translate(292.836 532.975) rotate(98)" fill="#f6faf1"/>
                        <path id="Path_5301" data-name="Path 5301"
                              d="M10.082,5.889C17.487-.73,29.5-2.166,37.568,3.621c5.811,4.166,8.951,11.3,9.753,18.4.963,8.538-1.272,17.579-6.874,24.094s-14.7,10.129-23.105,8.327C9.143,52.684,1.847,44.872.428,36.651-1.312,26.566,2.322,12.824,10.082,5.889Z"
                              transform="translate(290.123 533.591) rotate(98)" fill="none" stroke="#8bc549"
                              stroke-width="2"/>
                      </g>
                    </svg>
                    <span>
                    {{ idx + 1 }}
                  </span>
                  </div>
                  <div class="steps__step__text" v-if="step.text" v-html="step.text"></div>
                </div>
              </div>
            </div>
            <div data-aos="fade" class="shop-header bottom-silver-line">
              <div class="breadcrumbs">
                <a :href="links.home_url" title="Strona główna">Strona główna</a><span class="slash">/</span>Dla
                bliskich
              </div>
              <a :href="links.cart_url" title="Koszyk" class="cart">
                <svg id="Group_5070" data-name="Group 5070" xmlns="http://www.w3.org/2000/svg" width="26.45" height="23"
                     viewBox="0 0 26.45 23">
                  <path id="Path_4928" data-name="Path 4928"
                        d="M4.862,10a.863.863,0,0,0,0,1.725H8.3c1.427,3.535,2.834,7.077,4.25,10.62l-1.3,3.135a.863.863,0,0,0,.8,1.195H26.425a.863.863,0,1,0,0-1.725H13.344l.746-1.779,13.845-1.105a.887.887,0,0,0,.773-.665l1.725-7.475a.9.9,0,0,0-.845-1.051H10.622l-.934-2.336a.884.884,0,0,0-.8-.539Zm6.451,4.6H28.5l-1.339,5.8L14.054,21.446Zm3.612,12.65A2.875,2.875,0,1,0,17.8,30.125,2.888,2.888,0,0,0,14.925,27.25Zm8.625,0a2.875,2.875,0,1,0,2.875,2.875A2.888,2.888,0,0,0,23.55,27.25Zm-8.625,1.725a1.15,1.15,0,1,1-1.15,1.15A1.137,1.137,0,0,1,14.925,28.975Zm8.625,0a1.15,1.15,0,1,1-1.15,1.15A1.137,1.137,0,0,1,23.55,28.975Z"
                        transform="translate(-4 -10)" fill="#8bc549"/>
                </svg>
                Koszyk (<span class="js-count-cart-products">{{ cart.products.length }}</span>)
              </a>
            </div>
          </template>

          <template v-if="data.products && (tab === 0 || tab === 1)">
            <div class="row">
              <div class="col-md-4 col-lg-3 section__filters js-filter-content">
                <div class="hamburger section__filters__hamburger open js-filter-close">
                  <span></span>
                </div>
                <div data-aos="fade" class="section__filters__title">Filtry</div>
                <div data-aos="fade" v-for="parent in productParentCategories" class="filter">
                  <div class="filter__parent bottom-silver-line">{{ parent.name }}</div>
                  <label class="filter__child checkbox" :for="`category-${parent.category_nicename}`">
                    <input @input="setParentCategory($event, parent)" :id="`category-${parent.category_nicename}`"
                           type="checkbox"
                           v-model="parent.value">
                    <span class="checked"></span>
                    Wszystkie
<!--                    {{ parent.cat_ID }}-->
                  </label>
                  <template v-for="child in productCategories">
                    <label class="filter__child checkbox" v-if="child.parent === parent.cat_ID"
                           :for="`category-${child.category_nicename}`">
                      <input @input="setCategory($event, child)" :id="`category-${child.category_nicename}`"
                             type="checkbox" v-model="child.value">
                      <span class="checked"></span>
                      {{ child.name }}
<!--                      {{ child.cat_ID }}-->
                    </label>
                  </template>
                </div>
                <div data-aos="fade" class="filter">
                  <div class="filter__parent bottom-silver-line">Promocje</div>
                  <label class="filter__child checkbox" for="promotion">
                    <input @change="promotion = !promotion" id="promotion"
                           type="checkbox"
                           v-model="currentPromotion">
                    <span class="checked"></span>
                    Pokaż wszystkie
                  </label>
                </div>
                <div data-aos="fade" class="section__filters__bottom">
                  <div @click="getProducts" class="button button--green button--green--outline js-filter-close">
                    Zastosuj
                  </div>
                  <div @click="clearFilters" class="section__filters__clear">Wyczyść kryteria</div>
                </div>
              </div>
              <div data-aos="fade" class="col-md-8 col-lg-9">
                <div class="section__products">
                  <template v-if="products && products.length">
                    <template v-for="product in products">
                      <a :href="product.url + forLower" :title="product.name" class="product">
                        <div class="product__top">
                          <template v-if="product.productCategory && product.productCategory.length">
                            <img class="product__top__image" v-if="product.productCategory[0].image"
                                 :src="product.productCategory[0].image" :alt="product.name">
                            <div v-if="product.productCategory[0].name" class="product__top__category">
                              {{ product.productCategory[0].name }}
                            </div>
                          </template>
                          <h2 class="product__top__title">
                            {{ product.name }}
                            <!--                            <template v-for="item in product.category_ids"> {{ item }}</template>-->
                          </h2>
                        </div>
                        <div class="product__bottom">
                          od {{ product.price }} zł
                          <svg xmlns="http://www.w3.org/2000/svg" width="33.999" height="17.368"
                               viewBox="0 0 33.999 17.368">
                            <path id="Fill_1_Copy_6" data-name="Fill 1 Copy 6"
                                  d="M423.6,109.716l-1.505,1.685,6.862,5.879H399.736v2.24h29.218l-6.861,5.879,1.5,1.685,10.137-8.686Z"
                                  transform="translate(-399.736 -109.716)" fill="#8bc549"/>
                          </svg>
                        </div>
                      </a>
                    </template>
                  </template>
                  <template v-else>
                    <div class="content m-3">Nie znaleziono produktów</div>
                  </template>
                </div>
              </div>
            </div>
          </template>
          <template v-if="tab === 2">
            <template v-if="data.offers[2].acf.show_content && data.offers[2].acf.content">
              <div data-aos="fade" class="row section__main">
                <div v-if="data.offers[2].acf.content.list" class="col-md-6 c-left">
                  <div class="c-left__item" v-for="item in data.offers[2].acf.content.list">
                    <h3 data-aos="fade-up" class="h3 bottom-silver-line c-left__item__title" v-html="item.title"></h3>
                    <div data-aos="fade-up" class="content c-left__item__content" v-html="item.text"></div>
                  </div>
                </div>
                <div class="col-md-5 offset-md-1 c-right">
                  <img
                    data-aos="fade-up"
                    v-if="data.offers[2].acf.content.image"
                    :src="data.offers[2].acf.content.image.url"
                    :alt="data.offers[2].acf.content.image.alt"
                    :title="data.offers[2].acf.content.image.title"
                    class="c-right__image"
                  >
                  <div data-aos="fade-up" v-if="data.offers[2].acf.content.title"
                       class="c-right__title h2"
                  >{{ data.offers[2].acf.content.title }}
                  </div>
                  <div data-aos="fade-up" class="c-right__text" v-if="data.offers[2].acf.content.call">
                    {{ data.offers[2].acf.content.call }}
                    <a :href="`tel:${general.phone_number}`" :title="general.phone_number">{{
                        general.phone_number
                      }}</a>
                  </div>
                  <div data-aos="fade-up" class="c-right__text" v-if="data.offers[2].acf.content.write">
                    {{ data.offers[2].acf.content.write }}
                    <a :href="`mailto:${general.email}`" :title="general.email">{{ general.email }}</a>
                  </div>
                </div>
              </div>
            </template>
          </template>
        </div>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  props: {
    data: {
      type: Object,
      required: true
    },
    general: {
      type: Object,
      required: true
    },
    links: {
      type: Object,
      required: true
    },
    cart: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      countProducts: this.data.countProducts,
      tab: 0,
      currentCategories: [],
      currentPromotion: false,
      products: this.data.products,
      productParentCategories: this.data.productParentCategories,
      productCategories: this.data.productCategories,
      promotion: false,
    }
  },
  computed: {
    forLower() {
      if (this.tab === 1)
        return `?offer=friends`

      return ''
    }
  },
  created() {
    if (this.$route.query && this.$route.query.tab) {
      let tab = parseInt(this.$route.query.tab)

      if (this.data.offers && tab > this.data.offers.length) {
        return
      }

      this.tab = tab - 1
    }
  },
  methods: {
    async getProducts() {
      console.log('click')
      console.log(this.currentCategories)

      this.currentCategories = []

      for (let item of this.productParentCategories) {
        if (item.value) {
          this.currentCategories.push(item.cat_ID)
        }
      }

      for (let item of this.productCategories) {
        if (item.value) {
          this.currentCategories.push(item.cat_ID)
        }
      }


      try {
        const {data} = await this.$store.dispatch('AJAX_GET_PRODUCTS_BY_CATEGORY', {
          ids: this.currentCategories,
          promotion: this.promotion,
        })

        this.products = data.products
        this.countProducts = data.countProducts
      } catch (e) {
        console.log(e)
      }
    },
    setCategory(event, category) {
      if (event.target.checked) {
        for (let item of this.productParentCategories) {
          if (item.cat_ID === category.category_parent) {
            item.value = false
          }
        }
      }

      // if (event.target.checked) {
      //
      //   this.currentCategories.push(id)
      //   return
      // }
      //
      // const idx = this.currentCategories.indexOf(id)
      // this.currentCategories.splice(idx, 1)
    },
    setParentCategory(event, category) {
      console.log(category)

      if (event.target.checked) {
        for (let item of this.productCategories) {
          if (item.category_parent === category.cat_ID) {
            item.value = false
          }
        }
      }

      // if (event.target.checked) {
      //
      //   this.currentCategories.push(id)
      //   return
      // }
      //
      // const idx = this.currentCategories.indexOf(id)
      // this.currentCategories.splice(idx, 1)
    },
    clearFilters() {
      for (let cat of this.productCategories) {
        if (cat.parent !== 0) {
          cat.value = false
        }
      }

      for (let catParent of this.productParentCategories) {
        catParent.value = true
      }
      this.promotion = false
      this.currentPromotion = false
      this.currentCategories = []
    }
  }
}
</script>
